/* 
Juin 2010 - Martin Boudreault
PS : rechercher le terme 'production' pour modification finales  apporter au fichier
*/

$(document).ready(function(){	
	
	//	Constantes et variables globales - reus du xsl et/ou  initialises ici
	
	var $p = $("#param_galerie");		//Initialisation du slecteur de paramtres $p
	var const_serveur_rtmp = $p.attr("serveur_rtmp");
	var const_type_affichage =	$p.attr("type_affichage"); 	//	modal ou direct - paramtre
	var const_url_xml_galerie =	$p.attr("url_xml_galerie");
	var const_url_xml_videos =	$p.attr("url_xml_videos");
	var const_url_rep_thumbnails =	$p.attr("url_rep_thumbnails");
	var const_id_balise_video= $p.attr("div_video_maj");
	var const_num_videos_par_page = $p.attr("num_videos_par_page");
	var const_largeur_video_modal = 640;
	var const_largeur_video_direct = 545;
	var const_balise_affichage_video = '<div id="'+const_id_balise_video+'"><p>Vous ne disposez pas d&#8217;une version de Flash suffisamment r&#233;cente pour visualiser cette vid&#233;o. Vous pouvez t&#233;l&#233;charger la derni&#232;re version de Flash <a href="http://www.adobe.com/go/getflashplayer">ici</a>. Il est &#233;galement possible que JavaScript ne soit pas activ&#233;.</p></div>';
	
	
/********************   DEBUT parametrage de base de l'application au chargement   ********************************/

	//	Conditionnelles pour modifier le balisage en fonction du type d'affichage  prvoir : 'modal' ou 'direct'
	
	//1. Colorbox - nouveaux sites, mme page
	if(const_type_affichage =="modal"){	
			
			//Calcul de la largeur affichable
			var innerWidth = $(".enveloppe_galerie_video").width();
			//Masquage de la galerie
			$("#switch-visibilite").css('display','none');
			
			//cas 1-A : Chargement de la page avec un parametre video_id en _GET
			var video_id = getUrlVars()["video_id"];
			if( video_id != "" && video_id != null && video_id != undefined && video_id != '#' ){

				$.fn.colorbox({
					inline:true, 
					href:"#cbox-wrapper",
					innerWidth:innerWidth,
					scrolling:false,
					onComplete : function() { $(this).colorbox.resize();  }
				});
				
			}
		
		//Cas 1-B : clic sur un lien qui porte la classe colorbox
			
			$(".colorbox").colorbox({
					inline:true, 
					href:"#cbox-wrapper", 
					innerWidth:innerWidth, 
					scrolling:false,
					onComplete : function() { $(this).colorbox.resize();  }
			});
			
			
			
	//2. Affichage direct - anciens sites, sur une autre page
	}else if(const_type_affichage =="direct"){
		
		//Affichage de la galerie video
		$("#switch-visibilite").css('display','block');
		// retirer en production : utile pour in 69, fds /librairie_fr/galerie_video_anciens_sites.css incluse dans le mig des anciens sites
		var css_anciens_sites= "<link href='/pls/portal/docs/page/librairie_fr/media/styles/inc/galerie_video_anciens_sites.css' rel='stylesheet' type='text/css'>";
		$("head").append(css_anciens_sites);
	
	}
	
	
		/************** 	DEBUT pagination > load *********************/
	
	//	Extraction et initialisation de variables imporantes, pagination
	//	Variables initialises directement dans les fonctions : video_active + page_active
	var num_lmt_galerie	=	$("li.item_video>a").size();
	var num_pages = Math.ceil(num_lmt_galerie/const_num_videos_par_page);
	var video_active = "";
	get_active_video();
	var page_active= "";
  get_active_page(video_active);
	set_page_and_video_states(video_active,page_active);
	set_thumbnail_visibility (video_active,page_active);

		function get_active_video(){
			$("li.item_video").each(function() {	
					indice=$(this).index();
					if( $(this).hasClass("active")){
						video_active = indice;
					}
				});	
			}
			
			//Active la premire vido d'une page
			
			/*
			function set_active_video(selected_page){
				if(selected_page!=0){
				video_active = const_num_videos_par_page * selected_page;
				}else{ video_active= 0;}
			} 
			*/
			
			//Au lanceement et au chargement de page
			function set_thumbnail_visibility (video, page){
				
				//$('li.grp_pagination').addClass('first');
				
				first_visible_thumb = (const_num_videos_par_page * page);
				last_visible_thumb = (const_num_videos_par_page * (page+1));
				if (last_visible_thumb > num_lmt_galerie) { last_visible_thumb =  num_lmt_galerie ; }
				
					$("li.item_video").each(function() {										 
						 indice=$(this).index();	
						 
						 if( indice < first_visible_thumb || indice >= last_visible_thumb ) {
							 $(this).css("display", "none");
							}else{
								$(this).css("display", "block");
						 }
						 //retrait des pointills  chaque lment de dbut de page de thumbnails
						 if($(this).hasClass("grp_pagination")){
							 next = indice+1;
							 $("li.item_video:eq("+next+")").addClass('first');
						}
				});	
			}
		
		function get_active_page( video ){

				$("li.item_video").each(function() {														 
					indice=$(this).index();

					if ( $(this).hasClass("grp_pagination") ){
							if( video > indice){
								page	=	Math.ceil(indice/const_num_videos_par_page);
							}
						}
					if( typeof(page) == "undefined" ){ page=0; }
						page_active = page;
				});	
		}

		
		function set_page_and_video_states( video, page ){
			$("ul.pagination li a:eq("+page+")").addClass("selected");
		}
		
		/************** 	FIN pagination > load *********************/
		
		/************** 	DEBUT mnage des balises et tri > load *********************/
		
		deleteEmptyMetaElements();
		tagFirstMetaElements();
		
		//Suppression des balises de metadonnes vides au chargement de la page
		function deleteEmptyMetaElements(){
			
			$('.meta_video > ul > li').each(function(index) {
					 if ( $(this).text() =='' ) {$(this).remove();}
			});

			$('.propriete_video > ul > li').each(function(index) {
					 if ( $(this).text() =='' ) {$(this).remove();}
			});
			
		}
		
		//Suppression des balises de metadonnes vides au chargement de la page
		function resetMetaFirstClasses(){
			
			$('.meta_video > ul > li').each(function(index) {
					 $(this).removeClass('first')
			});

			$('.propriete_video > ul > li').each(function(index) {
					 $(this).removeClass('first')
			});
			
		}
		
		
		function tagFirstMetaElements(){
			$('.meta_video > ul > li:eq(0)').addClass('first');
			$('.propriete_video > ul > li:eq(0)').addClass('first');
		}

		/************** 	FIN mnage des balises et tri > load *********************/
	
	
	/********************   FIN parametrage de base de l'application au chargement   ********************************/

	/********************   DEBUT affichage et interaction secondaires au survol et au clic   ********************************/
	
	// 	Rollover liens - 
	$("li.item_video").hover(
  function () {
			$(this).addClass('over');
		}, 
		function () {
			$(this).removeClass('over');
		}
	);

	//	Prvenir le rechargement de la page au clic sur un lien vido
	$("li.item_video>a").click(function(event) {
			event.preventDefault();
		});
	
		/**** DEBUT pagination > click ****/															 
	$("ul.pagination>li").click(function() {
																				 
		//$("li.item_video:eq("+video_active+")").removeClass("active");
		$("ul.pagination li a:eq("+page_active+")").removeClass("selected");
		video_active = "";
		page_active= $(this).index();
		//set_active_video(page_active);
		set_page_and_video_states(video_active,page_active);
		set_thumbnail_visibility (video_active,page_active);
		
	});		
		/**** FIN pagination > click ****/		
	
	
	/********************   FIN affichage et interaction secondaires au survol et au clic   ********************************/
	
	//********************   DEBUT comportements principaux de navigation interne de la galerie   ********************************/
	$("li.item_video").click(function() {
			
			var id=$(this).attr("id");	
			//	id du thumbnail video cliqu
			
			$(".active").removeClass("active")	// retire la classe active   l'ancienne video
			$(this).addClass('active'); //affecte l'tat over  l'lment cliqu
		
			
			$.ajax({
				type: "GET",
				url: const_url_xml_videos,
				dataType: "xml",
				success: trouveNoeudVideo
			});
			
			
				
			//	Extraction d'un noeud spcifique	
			function trouveNoeudVideo(xml)
					{
						$(xml).find("video").each(function(){
								var idxml=$(this).attr("id"); 
								// id de la vido dans fichier xml
								if(id==idxml){
									
									afficheMetadonneesVideo($(this));
									afficheVideo($(this));
									$.fn.colorbox.resize()
								}	
						});

				}
		//********************   FIN comportements principaux de navigation interne de la galerie   ********************************/	
		//********************   DEBUT des fonctions   ********************************/
		
				//	Affichage des mtadonnes dans la plage vido
				//	La fonction est bien longue vu la validation qui doit avoir lieu - 
				//	Oprations de cration conditionnelle, suppression, mise  jour et tri de balises html
				function afficheMetadonneesVideo(noeud){
					
					//	Titre de la vido
					$('.titre_video').html( noeud.find("titre").text() );
					
					//	Dure de la vido 
					if ( $('.duree_video').length  ) { 										//	l'lment existe dans le code html
    				if ( noeud.find("duree").text() != ""){ 						//	l'information existe dans le fichier  xml
							$('.duree_video').html( "<strong>Dure&nbsp;:&nbsp;</strong>" );
							$('.duree_video').append( noeud.find("duree").text() );
						}else{
							//supprimer l'lment dans le html si le noeud xml n'existe pas
							$('.duree_video').remove();
						}
					}else{
						if ( noeud.find("duree").text() != ""){ 
						 //crer l'lment dans le html si il n'existe pas mais que le noeud xml est inform
						 $('.meta_video > ul').prepend("<li class='duree_video'><strong>Dure&nbsp;:&nbsp;</strong>"+ 
																					 noeud.find("duree").text() 
																					 +"</li>");
						}
					}
					
					//	Date de production de la vido 
					if ( $('.date_prod_video').length  ) { 										
						if ( noeud.find("date_realisation").text() != ""){ 						
							$('.date_prod_video').html( "<strong>Date de production&nbsp;:&nbsp;</strong>" );
							$('.date_prod_video').append( noeud.find("date_realisation").text() );
						}else{
							$('.date_prod_video').remove();
						}
					}else{
						if ( noeud.find("date_realisation").text() != ""){ 
						 $('.meta_video > ul').append("<li class='date_prod_video'><strong>Date de production&nbsp;:&nbsp;</strong>"+ 
																					 noeud.find("date_realisation").text() 
																					 +"</li>");
						}
						
					}
					
					//	Date de publication de la vido 
					if ( $('.date_publi_video').length  ) { 										
    				if ( noeud.find("date_mise_en_ligne").text() != ""){ 						
								$('.date_publi_video').html( "<strong>Date de publication&nbsp;:&nbsp;</strong>" );
								$('.date_publi_video').append( noeud.find("date_mise_en_ligne").text() );
						}else{
							$('.date_publi_video').remove();
						}
					}else{
						if ( noeud.find("date_mise_en_ligne").text() != ""){ 
						 $('.meta_video > ul').append("<li class='date_publi_video'><strong>Date de publication&nbsp;:&nbsp;</strong>"+ 
																					 noeud.find("date_mise_en_ligne").text() 
																					 +"</li>");
						}
					}
					
					//Description de la vido 
					if ( $('.description_video').length  ) { 										
    				if ( noeud.find("desc").text() != ""){ 						
							$('.description_video').html( noeud.find("desc").text() );
						}else{
							$('.description_video').remove();
						}
					}else{
						if ( noeud.find("date_realisation").text() != ""){ 
						 $('div.propriete_video"').before(" <p class='description_video'>"+ noeud.find("desc").text() +"</p>");
						}
					}
					
					//Auteur de la vido 
					if ( $('.auteur_video').length  ) { 										//	l'lment existe dans le code html
    				if ( noeud.find("auteur").text() != ""){ 						//	l'information existe dans le fichier  xml
							$('.auteur_video').html( noeud.find("auteur").text() );
						}else{
							//supprimmer l'lment dans le html si le noeud xml n'existe pas
							$('.auteur_video').remove();
						}
					}else{
						if ( noeud.find("auteur").text() != ""){ 
						 //crer l'lment dans le html si il n'existe pas mais que le noeud xml est inform
						 $('.propriete_video > ul').append("<li class='auteur_video'>"+ 
																					 noeud.find("auteur").text() 
																					 +"</li>");
						
						}
					}
					
					//	Copyright de la vido 
					if ( $('.copyright_video').length  ) { 										
    				if ( noeud.find("copyright").text() != ""){ 						
								$('.copyright_video').html( noeud.find("copyright").text() );
						}else{
							$('.copyright_video').remove();
						}
					}else{
						if ( noeud.find("copyright").text() != ""){ 
						 $('.propriete_video > ul').append("<li class='copyright_video'>"+ 
																					 noeud.find("copyright").text() 
																					 +"</li>");
						}
					}
					//Affecte la classe first au premier noeud des metadonnees, aprs avoir fait un nettoyage des balise first
					resetMetaFirstClasses();
					tagFirstMetaElements();

				}
				
				
				
				//	Traitement de la taille de la vido  afficher selon le type d'affichage, 
				//	retourne un tableau de format (largeur, hauteur)
				
					function set_video_size(type_affichage, largeur_native, hauteur_native ){
						
						var dimensions = Array();
						ratio = hauteur_native/largeur_native;
						
						//	largeur
						if (type_affichage=='modal'){
							largeur_affichable = const_largeur_video_modal;
						}else if(type_affichage=='direct'){
							largeur_affichable = const_largeur_video_direct;
						}
						
						dimensions[0] = largeur_affichable;
						
						//	hauteur
						hauteur_affichable = Math.round(largeur_affichable * ratio);
						dimensions[1] = hauteur_affichable;
						
						return dimensions;
						
					}
					
				//	Affichage de la vido
				function afficheVideo(noeud){
					
					//	Initialisation des paramtres
					var file = noeud.find("nom_fichier").text();
					var folder = noeud.find("rep_serveur").text();
					var native_width = noeud.find("largeur").text();
					var native_height = noeud.find("hauteur").text();
					var display_sizes = set_video_size(const_type_affichage, native_width, native_height );
					var width = display_sizes[0]; 
					var height = display_sizes[1]; 
					//fixer la taille du bloc contenant la vido
					set_video_container_height(height);
					
					//	Recherche le serveur rtmp dclar dans le noeud xml, 
					//	se rabat sur la valeur globale pour la galerie depuis le xsl
					var rtmp = noeud.find("rtmp").text();
					if(rtmp=="" || rtmp==null){
							rtmp = $p.attr("serveur_rtmp");
					}
					
					//Concatnation du chemin des images dans le groupe de pages et du noeud xml
					var still_image = const_url_rep_thumbnails+noeud.find("img_repos").text();
					var thumb = const_url_rep_thumbnails+noeud.find("prev_thumb").text();
					
					//	Suppression du noeud video, l'id du conteneur tant mainetenant une balise object et non un div.
					$("#AffichageVideo").remove();
					//	Cration d'un nouveau conteneur pour afficher la vido suivante
					$("div.bloc_video").prepend(const_balise_affichage_video);
					
					addFlashVideo(
										file,
										folder,
										width,
										height,
										rtmp,
										still_image,
										thumb,
										const_id_balise_video,
										'true'
					);

				}
				
				//Permet de conserver un bloc de hauteur fixe dans la page au moment de la destruction de la balise video
				function set_video_container_height(hauteur_plage_aff_video){
						hauteurbloc=hauteur_plage_aff_video+20 	//Controlleur lecteur video
						$("div.bloc_video").css('height',hauteurbloc);
				}


	});
	
	
	//********************   FIN des fonctions relatives au clic sur un thumbnail  ********************************/
	
	/* DEBUT Exceptions d'affichage relatives  IE6 */
	
	 if($.browser.msie){
		 if($.browser.version < 7){
		 	$("div.thumbnails").css({ 'position' : 'relative' ,'top':'-18px' });
	 	}	
	 }
	/* FIN Exceptions d'affichage relatives  IE6 */
	
	/********************   DEBUT comportements de clic et de hover sur le bloc teaser-galerie-video   ********************************/

		$('table.encadre-galerie-video td').hover(
			function () {
				$(this).addClass("over");
			}, 
			function () {
				$(this).removeClass("over");
			}
		);
		
		// Dans le cas ou les variable du portlet ne se trouvent pas dans la page - anciens sites - aff. sur autre page, la variable const_type_affichage ne sera pas dfinie
		if(! $("#param_galerie").length ){
				$('table.encadre-galerie-video td').click(function() {
						url = $('table.encadre-galerie-video td a').last().attr('href');
						document.location.href = url;
				});
		}

/********************   FIN comportements de clic et de hover sur le bloc teaser-galerie-video   ********************************/
	//fonction de dboguage : 
	
});	

